function R = q1_shade(ca, li, rho, lambda, vAng)

% Generate the depth map and compute p = dZ/dx & q = dZ/dy
Z = teapot(ca, vAng);
[p, q] = gradient(Z);

[n, m] = size(Z);
E = zeros(n, m);

for i = 1:n
    for j = 1:m 
        if Z(i,j) ~= 0        
            % Calculate irradiance
            normal = [-p(i,j); -q(i,j); -0.02] / norm([p(i,j); q(i,j); 0.02]);
            E(i,j) = rho * lambda * li * normal;
        end
    end
end

E(E < 0) = 0; % set all values that are negative to 0

R = E;

figure(1);
imagesc(E);