function retI = q2a(E)

% Sum the number of elements in E that are different than 0
n = sum(sum(E ~= 0));

% Compute the averages
muE = sum(E(:))/n;
muE2 = sum(E(:).^2)/n;

[Ex, Ey] = gradient(E);

% Get the unit vectors in the direction of [Ex, Ey]
unitEx = Ex./norm([Ex, Ey]);
unitEy = Ey./norm([Ex, Ey]);

% In case the norm was 0 and thus the result is not finite, set it back to
% 0
unitEx(~isfinite(unitEx)) = 0;
unitEy(~isfinite(unitEy)) = 0;

% Compute their averages
muUnitEx = sum(unitEx(:))/n;
muUnitEy = sum(unitEy(:))/n;

gamma = sqrt(6*pi.^2*muE2 - 48*muE^2); % (9.14a)
rho = gamma / pi;                      % (9.14)
sigma = acos(4*muE/gamma);             % (9.15)

% In some cases, sigma came out to be not real and returned an error
% thus check for not real values and set them to infinity
if ~isreal(sigma)
	sigma = inf; 
end

tau = atan(muUnitEy/muUnitEx);

display(rho);
display(sigma);
display(tau);

retI = [cos(tau)*sind(sigma); sin(tau)*sind(sigma); cos(sigma)];